/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.58 Revision 1.157
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.58 2010/02/02 14:20:16 reavertm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.157 2015/07/01 11:28:23 mrueg Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI 5. This will be
14# eclass will fail with version older than 2. 14# reviewed over time as new EAPI versions are approved.
15
16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
18
19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
25
26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
29
30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
31# @DESCRIPTION:
32# For proper description see virtualx.eclass manpage.
33# Here we redefine default value to be manual, if your package needs virtualx
34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
35: ${VIRTUALX_REQUIRED:=manual}
36
37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
38
39if [[ ${KDE_BUILD_TYPE} = live ]]; then
40 case ${KDE_SCM} in
41 svn) inherit subversion ;;
42 git) inherit git-r3 ;;
43 esac
44fi
15 45
16# @ECLASS-VARIABLE: CMAKE_REQUIRED 46# @ECLASS-VARIABLE: CMAKE_REQUIRED
17# @DESCRIPTION: 47# @DESCRIPTION:
18# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'. 48# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
19# Please note that if it's set to 'never' you need to explicitly override following phases: 49# Please note that if it's set to 'never' you need to explicitly override following phases:
20# src_configure, src_compile, src_test and src_install. 50# src_configure, src_compile, src_test and src_install.
21# Defaults to 'always'. 51# Defaults to 'always'.
22: ${CMAKE_REQUIRED:=always} 52: ${CMAKE_REQUIRED:=always}
23if [[ ${CMAKE_REQUIRED} = false || ${CMAKE_REQUIRED} = never ]]; then 53if [[ ${CMAKE_REQUIRED} = always ]]; then
24 buildsystem_eclass=""
25 export_fns=""
26else
27 buildsystem_eclass="cmake-utils" 54 buildsystem_eclass="cmake-utils"
28 export_fns="src_configure src_compile src_test src_install" 55 export_fns="src_configure src_compile src_test src_install"
29fi 56fi
30 57
31inherit kde4-functions 58# @ECLASS-VARIABLE: KDE_MINIMAL
59# @DESCRIPTION:
60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
61# version for apps to work. Currently defaults to 4.4
62# One may override this variable to raise version requirements.
63# Note that it is fixed to ${PV} for kde-base packages.
64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
32 65
33get_build_type 66# Set slot for KDEBASE known packages
67case ${KDEBASE} in
68 kde-base)
69 SLOT=4/$(get_version_component_range 1-2)
70 KDE_MINIMAL="${PV}"
71 ;;
72 kdevelop)
34if [[ ${BUILD_TYPE} = live ]]; then 73 if [[ ${KDE_BUILD_TYPE} = live ]]; then
35 subversion_eclass="subversion" 74 # @ECLASS-VARIABLE: KDEVELOP_VERSION
36fi 75 # @DESCRIPTION:
76 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
77 # Applies to KDEBASE=kdevelop only.
78 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
79 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
80 # @DESCRIPTION:
81 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
82 # Applies to KDEBASE=kdevelop only.
83 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
84 else
85 case ${PN} in
86 kdevelop)
87 KDEVELOP_VERSION=${PV}
88 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
89 ;;
90 kdevplatform|kdevelop-php*|kdevelop-python)
91 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
92 KDEVPLATFORM_VERSION=${PV}
93 ;;
94 *)
95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
96 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
97 esac
98 fi
99 SLOT="4"
100 ;;
101esac
37 102
38inherit base ${buildsystem_eclass} eutils ${subversion_eclass} 103inherit ${buildsystem_eclass}
39 104
40EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm 105EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
41 106
42unset buildsystem_eclass 107unset buildsystem_eclass
43unset export_fns 108unset export_fns
44unset subversion_eclass
45 109
110# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
111# @DESCRIPTION:
112# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
113# This variable must be set before inheriting any eclasses. Defaults to 'never'.
114DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
115
116# @ECLASS-VARIABLE: QTHELP_REQUIRED
117# @DESCRIPTION:
118# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
119# This variable must be set before inheriting any eclasses. Defaults to 'never'.
120QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
121
122# @ECLASS-VARIABLE: OPENGL_REQUIRED
123# @DESCRIPTION:
124# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
125# This variable must be set before inheriting any eclasses. Defaults to 'never'.
126OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
127
128# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
129# @DESCRIPTION:
130# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
131# This variable must be set before inheriting any eclasses. Defaults to 'never'.
132MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
133
134# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
135# @DESCRIPTION:
136# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
137# This variable must be set before inheriting any eclasses. Defaults to 'never'.
138CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
139
140# @ECLASS-VARIABLE: KDE_REQUIRED
141# @DESCRIPTION:
142# Is kde required? Possible values are 'always', 'optional' and 'never'.
143# This variable must be set before inheriting any eclasses. Defaults to 'always'
144# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
145# Note that for kde-base packages this variable is fixed to 'always'.
146KDE_REQUIRED="${KDE_REQUIRED:-always}"
147
148# @ECLASS-VARIABLE: KDE_HANDBOOK
149# @DESCRIPTION:
150# Set to enable handbook in application. Possible values are 'always', 'optional'
151# (handbook USE flag) and 'never'.
152# This variable must be set before inheriting any eclasses. Defaults to 'never'.
153# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
154# ensures buildtime and runtime dependencies.
155KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
156
157# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
158# @DESCRIPTION:
159# Set this varible if you want your live package to manage its
160# translations. (Mostly all kde ebuilds does not ship documentation
161# and translations in live ebuilds)
162if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
163 # Kdebase actualy provides the handbooks even for live stuff
164 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
165 KDE_LINGUAS=""
166fi
167
168# Setup packages inheriting this eclass
46case ${KDEBASE} in 169case ${KDEBASE} in
47 kde-base) 170 kde-base)
48 HOMEPAGE="http://www.kde.org/" 171 HOMEPAGE="http://www.kde.org/"
49 LICENSE="GPL-2" 172 LICENSE="GPL-2"
50 ;; 173 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
51 koffice)
52 HOMEPAGE="http://www.koffice.org/"
53 LICENSE="GPL-2"
54 ;;
55esac
56
57# @ECLASS-VARIABLE: OPENGL_REQUIRED
58# @DESCRIPTION:
59# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
60# This variable must be set before inheriting any eclasses. Defaults to 'never'.
61OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
62
63# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
64# @DESCRIPTION:
65# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
66# This variable must be set before inheriting any eclasses. Defaults to 'never'.
67MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
68
69# @ECLASS-VARIABLE: WEBKIT_REQUIRED
70# @DESCRIPTION:
71# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
72# This variable must be set before inheriting any eclasses. Defaults to 'never'.
73WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
74
75# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
76# @DESCRIPTION:
77# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
78# This variable must be set before inheriting any eclasses. Defaults to 'never'.
79CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
80
81# @ECLASS-VARIABLE: KDE_REQUIRED
82# @DESCRIPTION:
83# Is kde required? Possible values are 'always', 'optional' and 'never'.
84# This variable must be set before inheriting any eclasses. Defaults to 'always'
85# If set to always or optional, KDE_MINIMAL may be overriden as well.
86# Note that for kde-base packages this variable is fixed to 'always'.
87KDE_REQUIRED="${KDE_REQUIRED:-always}"
88
89# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
90if [[ -n ${KDE_MINIMAL} ]]; then
91 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
92 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
93 done
94 unset slot
95 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
96else
97 KDE_MINIMAL_VALID=1
98fi
99
100# @ECLASS-VARIABLE: KDE_MINIMAL
101# @DESCRIPTION:
102# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
103# version for apps to work. Currently defaults to 4.3
104# One may override this variable to raise version requirements.
105# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
106# Note that it is fixed to ${SLOT} for kde-base packages.
107KDE_MINIMAL="${KDE_MINIMAL:-4.3}"
108
109# Setup packages inheriting this eclass
110case ${KDEBASE} in
111 kde-base)
112 if [[ $BUILD_TYPE = live ]]; then
113 # Disable tests for live ebuilds 174 # Disable tests for live ebuilds by default
114 RESTRICT+=" test" 175 RESTRICT+=" test"
115 # Live ebuilds in kde-base default to kdeprefix by default
116 IUSE+=" +kdeprefix"
117 else
118 # All other ebuild types default to -kdeprefix as before
119 IUSE+=" kdeprefix"
120 fi 176 fi
121 # Determine SLOT from PVs 177
122 case ${PV} in
123 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
124 4.5* | 4.4.[6-9]*) SLOT="4.5" ;;
125 4.4* | 4.3.[6-9]*) SLOT="4.4" ;;
126 4.3*) SLOT="4.3" ;;
127 9999*) SLOT="live" ;; # regular live
128 *) die "Unsupported ${PV}" ;;
129 esac
130 # This code is to prevent portage from searching GENTOO_MIRRORS for 178 # This code is to prevent portage from searching GENTOO_MIRRORS for
131 # packages that will never be mirrored. (As they only will ever be in 179 # packages that will never be mirrored. (As they only will ever be in
132 # the overlay). 180 # the overlay).
133 case ${PV} in 181 case ${PV} in
134 *9999* | 4.?.[6-9]?) 182 *9999* | 4.?.[6-9]? | 4.??.[6-9]? | ??.?.[6-9]? | ??.??.[6-9]?)
135 RESTRICT+=" mirror" 183 RESTRICT+=" mirror"
136 ;; 184 ;;
137 esac 185 esac
138 KDE_MINIMAL="${SLOT}"
139 _kdedir="${SLOT}"
140
141 # Block installation of other SLOTS unless kdeprefix
142 RDEPEND+=" $(block_other_slots)"
143 ;; 186 ;;
144 koffice) 187 kdevelop)
145 SLOT="2" 188 HOMEPAGE="http://www.kdevelop.org/"
189 LICENSE="GPL-2"
146 ;; 190 ;;
147esac 191esac
148 192
149# @ECLASS-VARIABLE: QT_MINIMAL 193# @ECLASS-VARIABLE: QT_MINIMAL
150# @DESCRIPTION: 194# @DESCRIPTION:
151# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1.. 195# Determine version of qt we enforce as minimal for the package.
152# Currently defaults to 4.5.1 for KDE 4.3 and earlier
153# or 4.6.0_rc1 for KDE 4.4 and later
154if slot_is_at_least 4.4 "${KDE_MINIMAL}"; then
155 QT_MINIMAL="${QT_MINIMAL:-4.6.0}"
156fi
157
158QT_MINIMAL="${QT_MINIMAL:-4.5.1}" 196QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
197
198# Declarative dependencies
199qtdeclarativedepend="
200 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
201"
202case ${DECLARATIVE_REQUIRED} in
203 always)
204 COMMONDEPEND+=" ${qtdeclarativedepend}"
205 ;;
206 optional)
207 IUSE+=" declarative"
208 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
209 ;;
210 *) ;;
211esac
212unset qtdeclarativedepend
213
214# QtHelp dependencies
215qthelpdepend="
216 >=dev-qt/qthelp-${QT_MINIMAL}:4
217"
218case ${QTHELP_REQUIRED} in
219 always)
220 COMMONDEPEND+=" ${qthelpdepend}"
221 ;;
222 optional)
223 IUSE+=" qthelp"
224 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
225 ;;
226esac
227unset qthelpdepend
159 228
160# OpenGL dependencies 229# OpenGL dependencies
161qtopengldepend=" 230qtopengldepend="
162 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 231 >=dev-qt/qtopengl-${QT_MINIMAL}:4
163" 232"
164case ${OPENGL_REQUIRED} in 233case ${OPENGL_REQUIRED} in
165 always) 234 always)
166 COMMONDEPEND+=" ${qtopengldepend}" 235 COMMONDEPEND+=" ${qtopengldepend}"
167 ;; 236 ;;
173esac 242esac
174unset qtopengldepend 243unset qtopengldepend
175 244
176# MultiMedia dependencies 245# MultiMedia dependencies
177qtmultimediadepend=" 246qtmultimediadepend="
178 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4 247 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
179" 248"
180case ${MULTIMEDIA_REQUIRED} in 249case ${MULTIMEDIA_REQUIRED} in
181 always) 250 always)
182 COMMONDEPEND+=" ${qtmultimediadepend}" 251 COMMONDEPEND+=" ${qtmultimediadepend}"
183 ;; 252 ;;
186 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )" 255 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
187 ;; 256 ;;
188 *) ;; 257 *) ;;
189esac 258esac
190unset qtmultimediadepend 259unset qtmultimediadepend
191
192# WebKit dependencies
193case ${KDE_REQUIRED} in
194 always)
195 qtwebkitusedeps="[kde]"
196 ;;
197 optional)
198 qtwebkitusedeps="[kde?]"
199 ;;
200 *) ;;
201esac
202qtwebkitdepend="
203 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
204"
205unset qtwebkitusedeps
206case ${WEBKIT_REQUIRED} in
207 always)
208 COMMONDEPEND+=" ${qtwebkitdepend}"
209 ;;
210 optional)
211 IUSE+=" webkit"
212 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
213 ;;
214 *) ;;
215esac
216unset qtwebkitdepend
217 260
218# CppUnit dependencies 261# CppUnit dependencies
219cppuintdepend=" 262cppuintdepend="
220 dev-util/cppunit 263 dev-util/cppunit
221" 264"
230 *) ;; 273 *) ;;
231esac 274esac
232unset cppuintdepend 275unset cppuintdepend
233 276
234# KDE dependencies 277# KDE dependencies
278# Qt accessibility classes are needed in various places, bug 325461
235kdecommondepend=" 279kdecommondepend="
236 dev-lang/perl 280 dev-lang/perl
281 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
237 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 282 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
283 >=dev-qt/qtdbus-${QT_MINIMAL}:4
284 >=dev-qt/designer-${QT_MINIMAL}:4
238 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 285 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
239 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
240 >=x11-libs/qt-script-${QT_MINIMAL}:4 286 >=dev-qt/qtscript-${QT_MINIMAL}:4
241 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 287 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
242 >=x11-libs/qt-svg-${QT_MINIMAL}:4 288 >=dev-qt/qtsvg-${QT_MINIMAL}:4
243 >=x11-libs/qt-test-${QT_MINIMAL}:4 289 >=dev-qt/qttest-${QT_MINIMAL}:4
290 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
291"
292
293if [[ ${PN} != kdelibs ]]; then
294 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
295 if [[ ${KDEBASE} = kdevelop ]]; then
296 if [[ ${PN} != kdevplatform ]]; then
297 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
298 # @DESCRIPTION:
299 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
300 # Applies to KDEBASE=kdevelop only.
301 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
302 case ${KDEVPLATFORM_REQUIRED} in
303 always)
304 kdecommondepend+="
305 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
306 "
307 ;;
308 *) ;;
309 esac
310 fi
311 fi
312fi
313
314kdedepend="
315 dev-util/automoc
316 virtual/pkgconfig
244 !aqua? ( 317 !aqua? (
245 x11-libs/libXext
246 x11-libs/libXt 318 >=x11-libs/libXtst-1.1.0
247 x11-libs/libXxf86vm
248 )
249"
250if [[ ${PN} != kdelibs ]]; then
251 if [[ ${KDEBASE} = kde-base ]]; then
252 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
253 # libknotificationitem only when SLOT is 4.3
254 [[ ${PN} != libknotificationitem ]] && [[ ${SLOT} = 4.3 ]] && \
255 kdecommondepend+=" $(add_kdebase_dep libknotificationitem)"
256 else
257 kdecommondepend+="
258 >=kde-base/kdelibs-${KDE_MINIMAL}
259 "
260 fi
261fi
262kdedepend="
263 dev-util/pkgconfig
264 !aqua? (
265 || ( >=x11-libs/libXtst-1.1.0 <x11-proto/xextproto-7.1.0 )
266 x11-proto/xf86vidmodeproto 319 x11-proto/xf86vidmodeproto
267 ) 320 )
268" 321"
322
323kderdepend=""
324
325if [[ ${CATEGORY} == kde-apps ]]; then
326 kderdepend+=" !kde-base/${PN}"
327fi
328
329# all packages needs oxygen icons for basic iconset
330if [[ ${PN} != oxygen-icons ]]; then
331 kderdepend+=" kde-apps/oxygen-icons"
332fi
333
334# add a dependency over kde-l10n
335if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
336 for _lingua in ${KDE_LINGUAS}; do
337 # if our package has linguas, pull in kde-l10n with selected lingua enabled,
338 # but only for selected ones.
339 # this can't be done on one line because if user doesn't use any localisation
340 # then he is probably not interested in kde-l10n at all.
341 kderdepend+="
342 linguas_${_lingua}? ( $(add_kdeapps_dep kde4-l10n "linguas_${_lingua}(+)") )
343 "
344 done
345 unset _lingua
346fi
347
348kdehandbookdepend="
349 app-text/docbook-xml-dtd:4.2
350 app-text/docbook-xsl-stylesheets
351"
352kdehandbookrdepend="
353 $(add_kdebase_dep kdelibs 'handbook')
354"
355case ${KDE_HANDBOOK} in
356 always)
357 kdedepend+=" ${kdehandbookdepend}"
358 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
359 ;;
360 optional)
361 IUSE+=" +handbook"
362 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
363 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
364 ;;
365 *) ;;
366esac
367unset kdehandbookdepend kdehandbookrdepend
368
369case ${KDE_SELINUX_MODULE} in
370 none) ;;
371 *)
372 IUSE+=" selinux"
373 kderdepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
374 ;;
375esac
376
377# We always need the aqua useflag because otherwise we cannot = refer to it inside
378# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
379# (where referring to a use flag not in IUSE masks the ebuild).
380# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
381IUSE+=" aqua"
382
269case ${KDE_REQUIRED} in 383case ${KDE_REQUIRED} in
270 always) 384 always)
271 IUSE+=" aqua" 385 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
272 COMMONDEPEND+=" ${kdecommondepend}" 386 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
273 DEPEND+=" ${kdedepend}" 387 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
274 ;; 388 ;;
275 optional) 389 optional)
276 IUSE+=" aqua kde" 390 IUSE+=" kde"
277 COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 391 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
278 DEPEND+=" kde? ( ${kdedepend} )" 392 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
393 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
279 ;; 394 ;;
280 *) ;; 395 *) ;;
281esac 396esac
282 397
283unset kdecommondepend kdedepend 398unset kdecommondepend kdedepend kderdepend
284 399
285debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}" 400debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
286debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}" 401debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
287debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}" 402debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
288 403
289# Accumulate dependencies set by this eclass 404# Accumulate dependencies set by this eclass
290DEPEND+=" ${COMMONDEPEND}" 405DEPEND+=" ${COMMONDEPEND}"
291RDEPEND+=" ${COMMONDEPEND}" 406RDEPEND+=" ${COMMONDEPEND}"
292unset COMMONDEPEND 407unset COMMONDEPEND
293 408
294# Add experimental kdeenablefinal, disabled by default
295IUSE+=" kdeenablefinal"
296
297# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 409# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
298# koffice ebuild, the URI should be set in the ebuild itself 410# kdevelop ebuild, the URI should be set in the ebuild itself
299case ${BUILD_TYPE} in 411_calculate_src_uri() {
300 live) 412 debug-print-function ${FUNCNAME} "$@"
301 # Determine branch URL based on live type 413
302 local branch_prefix 414 local _kmname _kmname_pv
415
416 # we calculate URI only for known KDEBASE modules
417 [[ -n ${KDEBASE} ]] || return
418
419 # calculate tarball module name
420 if [[ -n ${KMNAME} ]]; then
421 _kmname="${KMNAME}"
422 else
423 _kmname=${PN}
424 fi
425 _kmname_pv="${_kmname}-${PV}"
426 case ${KDEBASE} in
427 kde-base)
303 case ${PV} in 428 case ${PV} in
304 9999*) 429 4.4.11.1)
305 # trunk 430 # KDEPIM 4.4, special case
306 branch_prefix="trunk/KDE" 431 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
432 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
433 4.4.20*)
434 # KDEPIM 4.4 no-akonadi branch, special case
435 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
436 SRC_URI="http://dev.gentoo.org/~dilfridge/distfiles/${_kmname_pv}.tar.xz" ;;
437 4.?.[6-9]? | 4.??.[6-9]?)
438 # Unstable KDE SC releases
439 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
440 4.11.14)
441 # Part of 4.14 actually, sigh. Not stable for next release!
442 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
443 4.11.17)
444 # Part of 14.12.3 actually, sigh. Not stable for next release!
445 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
446 4.11.18)
447 # Part of 15.04.0 actually, sigh. Not stable for next release!
448 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
449 4.11.19)
450 # Part of 15.04.1 actually, sigh. Not stable for next release!
451 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
452 4.11.20)
453 # Part of 15.04.2 actually, sigh. Not stable for next release!
454 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
455 4.11.21)
456 # Part of 15.04.3 actually, sigh. Not stable for next release!
457 SRC_URI="mirror://kde/stable/applications/15.04.3/src/${_kmname_pv}.tar.xz" ;;
458 4.14.3)
459 # Last SC release
460 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
461 4.14.6)
462 # Part of 14.12.3 actually, sigh. Not stable for next release!
463 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
464 4.14.7)
465 # Part of 15.04.0 actually, sigh. Not stable for next release!
466 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
467 4.14.8)
468 # Part of 15.04.1 actually, sigh. Not stable for next release!
469 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
470 4.14.9)
471 # Part of 15.04.2 actually, sigh. Not stable for next release!
472 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
473 4.14.10)
474 # Part of 15.04.3 actually, sigh. Not stable for next release!
475 SRC_URI="mirror://kde/stable/applications/15.04.3/src/${_kmname_pv}.tar.xz" ;;
476 ??.?.[6-9]? | ??.??.[4-9]?)
477 # Unstable KDE Applications releases
478 SRC_URI="mirror://kde/unstable/applications/${PV}/src/${_kmname}-${PV}.tar.xz" ;;
479 *)
480 # Stable KDE Applications releases
481 SRC_URI="mirror://kde/stable/applications/${PV}/src/${_kmname}-${PV}.tar.xz"
307 ;; 482 ;;
308 *)
309 # branch
310 branch_prefix="branches/KDE/${SLOT}"
311 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
312 # @DESCRIPTION
313 # Suffix appended to ESVN_PROJECT depending on fetched branch.
314 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
315 ESVN_PROJECT_SUFFIX="-${PV}"
316 ;;
317 esac 483 esac
484 ;;
485 kdevelop|kdevelop-php*|kdevplatform)
486 case ${KDEVELOP_VERSION} in
487 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
488 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
489 esac
490 ;;
491 esac
492}
493
494_calculate_live_repo() {
495 debug-print-function ${FUNCNAME} "$@"
496
318 SRC_URI="" 497 SRC_URI=""
319 # @ECLASS-VARIABLE: ESVN_MIRROR 498 case ${KDE_SCM} in
320 # @DESCRIPTION: 499 svn)
321 # This variable allows easy overriding of default kde mirror service 500 # Determine branch URL based on live type
322 # (anonsvn) with anything else you might want to use. 501 local branch_prefix
323 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
324 # Split ebuild, or extragear stuff
325 if [[ -n ${KMNAME} ]]; then
326 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
327 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
328 KMMODULE="${PN}"
329 fi
330 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
331 case ${KMNAME} in 502 case ${PV} in
332 kdebase-*) 503 9999*)
333 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}" 504 # trunk
334 ;; 505 branch_prefix="trunk/KDE"
335 kdelibs-*)
336 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
337 ;;
338 kdereview*)
339 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
340 ;;
341 kdesupport)
342 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
343 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
344 ;;
345 kde*)
346 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
347 ;;
348 extragear*|playground*)
349 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
350 # build packages from same svn location.
351 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
352 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
353 ;;
354 koffice)
355 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
356 ;; 506 ;;
357 *) 507 *)
358 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 508 # branch
509 branch_prefix="branches/KDE/$(get_kde_version)"
510 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
511 # @DESCRIPTION
512 # Suffix appended to ESVN_PROJECT depending on fetched branch.
513 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
514 ESVN_PROJECT_SUFFIX="-${PV}"
359 ;; 515 ;;
360 esac 516 esac
361 else
362 # kdelibs, kdepimlibs
363 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
364 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
365 fi
366 # @ECLASS-VARIABLE: ESVN_UP_FREQ 517 # @ECLASS-VARIABLE: ESVN_MIRROR
367 # @DESCRIPTION: 518 # @DESCRIPTION:
368 # This variable is used for specifying the timeout between svn synces 519 # This variable allows easy overriding of default kde mirror service
369 # for kde-base and koffice modules. Does not affect misc apps. 520 # (anonsvn) with anything else you might want to use.
370 # Default value is 1 hour. 521 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
371 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 522 # Split ebuild, or extragear stuff
372 ;;
373 *)
374 if [[ -n ${KDEBASE} ]]; then
375 if [[ -n ${KMNAME} ]]; then 523 if [[ -n ${KMNAME} ]]; then
524 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
525 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
526 KMMODULE="${PN}"
527 fi
528 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
376 case ${KMNAME} in 529 case ${KMNAME} in
377 kdebase-apps) 530 kdebase-*)
378 _kmname="kdebase" ;; 531 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
532 ;;
533 kdelibs-*)
534 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
535 ;;
536 kdereview*)
537 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
538 ;;
539 kdesupport)
540 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
541 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
542 ;;
543 kde*)
544 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
545 ;;
546 extragear*|playground*)
547 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
548 # build packages from same svn location.
549 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
550 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
551 ;;
379 *) 552 *)
380 _kmname="${KMNAME}" ;; 553 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
554 ;;
381 esac 555 esac
556 else
557 # kdelibs, kdepimlibs
558 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
559 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
560 fi
561 # @ECLASS-VARIABLE: ESVN_UP_FREQ
562 # @DESCRIPTION:
563 # This variable is used for specifying the timeout between svn synces
564 # for kde-base modules. Does not affect misc apps.
565 # Default value is 1 hour.
566 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
567 ;;
568 git)
569 local _kmname
570 # @ECLASS-VARIABLE: EGIT_MIRROR
571 # @DESCRIPTION:
572 # This variable allows easy overriding of default kde mirror service
573 # (anongit) with anything else you might want to use.
574 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
575
576 # @ECLASS-VARIABLE: EGIT_REPONAME
577 # @DESCRIPTION:
578 # This variable allows overriding of default repository
579 # name. Specify only if this differ from PN and KMNAME.
580 if [[ -n ${EGIT_REPONAME} ]]; then
581 # the repository and kmname different
582 _kmname=${EGIT_REPONAME}
583 elif [[ -n ${KMNAME} ]]; then
584 _kmname=${KMNAME}
382 else 585 else
383 _kmname=${PN} 586 _kmname=${PN}
384 fi 587 fi
385 _kmname_pv="${_kmname}-${PV}" 588
386 case ${KDEBASE} in 589 # default branching
387 kde-base) 590 [[ ${PV} != 4.9999* && ${PV} != 9999 && ${KDEBASE} == kde-base ]] && \
388 case ${PV} in 591 EGIT_BRANCH="KDE/$(get_kde_version)"
389 4.[34].8[05] | 4.[34].9[0568]) 592
390 # block for normally packed unstable releases 593 # Applications branching
391 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 594 [[ ${PV} == ??.??.49.9999 && ${KDEBASE} == kde-base ]] && \
392 4.[34].[6-9]*) 595 EGIT_BRANCH="Applications/$(get_kde_version)"
393 # Repacked tarballs: need to depend on xz-utils to ensure that they can be unpacked 596
394 SRC_URI="http://dev.gentooexperimental.org/~alexxy/kde/${PV}/${_kmname_pv}.tar.xz" 597 # default repo uri
395 DEPEND+=" app-arch/xz-utils" 598 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
396 ;; 599
397 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 600 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
398 esac 601 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
399 ;;
400 koffice)
401 case ${PV} in
402 2.0.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" ;;
403 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
404 esac
405 esac
406 unset _kmname _kmname_pv
407 fi
408 ;; 602 ;;
603 esac
604}
605
606case ${KDE_BUILD_TYPE} in
607 live) _calculate_live_repo ;;
608 *) _calculate_src_uri ;;
409esac 609esac
410 610
411debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 611debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
412 612
413# @ECLASS-VARIABLE: PREFIX 613# @ECLASS-VARIABLE: PREFIX
414# @DESCRIPTION: 614# @DESCRIPTION:
415# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 615# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
416# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 616# kde-base packages go into KDE4 installation directory (/usr).
417# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 617# No matter the PREFIX, package will be built against KDE installed in /usr.
418 618
419# @FUNCTION: kde4-base_pkg_setup 619# @FUNCTION: kde4-base_pkg_setup
420# @DESCRIPTION: 620# @DESCRIPTION:
421# Do the basic kdeprefix KDEDIR settings and determine with which kde should 621# Do some basic settings
422# optional applications link
423kde4-base_pkg_setup() { 622kde4-base_pkg_setup() {
424 debug-print-function ${FUNCNAME} "$@" 623 debug-print-function ${FUNCNAME} "$@"
425 624
426 # Prefix compat: 625 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
427 if [[ ${EAPI} == 2 ]] && ! use prefix; then 626 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
428 EPREFIX= 627 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
429 EROOT=${ROOT}
430 fi 628 fi
431
432 # Append missing trailing slash character
433 [[ ${EROOT} = */ ]] || EROOT+="/"
434
435 # QA ebuilds
436 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
437 629
438 # Don't set KDEHOME during compilation, it will cause access violations 630 # Don't set KDEHOME during compilation, it will cause access violations
439 unset KDEHOME 631 unset KDEHOME
440 632
441 if [[ ${KDEBASE} = kde-base ]]; then 633 # Check if gcc compiler is fresh enough.
442 if use kdeprefix; then 634 # In theory should be in pkg_pretend but we check it only for kdelibs there
443 KDEDIR=/usr/kde/${_kdedir} 635 # and for others we do just quick scan in pkg_setup because pkg_pretend
444 else 636 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
637 if [[ ${MERGE_TYPE} != binary ]]; then
638 [[ $(gcc-major-version) -lt 4 ]] || \
639 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
640 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
641 fi
642
445 KDEDIR=/usr 643 KDEDIR=/usr
446 fi
447 : ${PREFIX:=${KDEDIR}}
448 else
449 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
450 KDEDIR=
451 local kde_minimal_met
452 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
453 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
454 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
455 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
456 KDEDIR=/usr/kde/${slot}
457 else
458 KDEDIR=/usr
459 fi
460 break;
461 fi
462 done
463 unset slot
464
465 # Bail out if kdelibs required but not found
466 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
467 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
468 else
469 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
470 fi
471
472 : ${PREFIX:=/usr} 644 : ${PREFIX:=/usr}
473 fi 645 EKDEDIR=${EPREFIX}/usr
474 EKDEDIR=${EPREFIX}${KDEDIR}
475 646
476 # Point pkg-config path to KDE *.pc files
477 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
478 # Point to correct QT plugins path 647 # Point to correct QT plugins path
479 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 648 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
480 649
481 # Fix XDG collision with sandbox 650 # Fix XDG collision with sandbox
482 export XDG_CONFIG_HOME="${T}" 651 export XDG_CONFIG_HOME="${T}"
483 # Not needed anymore
484 unset _kdedir
485} 652}
486 653
487# @FUNCTION: kde4-base_src_unpack 654# @FUNCTION: kde4-base_src_unpack
488# @DESCRIPTION: 655# @DESCRIPTION:
489# This function unpacks the source tarballs for KDE4 applications. 656# This function unpacks the source tarballs for KDE4 applications.
490kde4-base_src_unpack() { 657kde4-base_src_unpack() {
491 debug-print-function ${FUNCNAME} "$@" 658 debug-print-function ${FUNCNAME} "$@"
492 659
493 if [[ ${BUILD_TYPE} = live ]]; then 660 if [[ ${KDE_BUILD_TYPE} = live ]]; then
494 migrate_store_dir 661 case ${KDE_SCM} in
662 svn)
495 subversion_src_unpack 663 subversion_src_unpack
496 elif [[ ${EAPI} == 2 ]]; then
497 local file
498 for file in ${A}; do
499 # This setup is because EAPI <= 2 cannot unpack *.tar.xz files
500 # directly, so we do it ourselves (using the exact same code as portage)
501 case ${file} in
502 *.tar.xz)
503 echo ">>> Unpacking ${file} to ${PWD}"
504 xz -dc "${DISTDIR}"/${file} | tar xof -
505 assert "failed unpacking ${file}"
506 ;; 664 ;;
507 *) 665 git)
508 unpack ${file} 666 git-r3_src_unpack
509 ;; 667 ;;
510 esac 668 esac
511 done
512 else 669 else
513 # For EAPI >= 3, we can just use unpack() directly
514 unpack ${A} 670 unpack ${A}
515 fi 671 fi
516} 672}
517 673
518# @FUNCTION: kde4-base_src_prepare 674# @FUNCTION: kde4-base_src_prepare
522# enable_selected_linguas() and enable_selected_doc_linguas() 678# enable_selected_linguas() and enable_selected_doc_linguas()
523# in kde4-functions.eclass(5) for further details. 679# in kde4-functions.eclass(5) for further details.
524kde4-base_src_prepare() { 680kde4-base_src_prepare() {
525 debug-print-function ${FUNCNAME} "$@" 681 debug-print-function ${FUNCNAME} "$@"
526 682
683 # enable handbook and linguas only when not using live ebuild
684
527 # Only enable selected languages, used for KDE extragear apps. 685 # Only enable selected languages, used for KDE extragear apps.
528 if [[ -n ${KDE_LINGUAS} ]]; then 686 if [[ -n ${KDE_LINGUAS} ]]; then
529 enable_selected_linguas 687 enable_selected_linguas
530 fi 688 fi
531 689
532 # Enable/disable handbooks for kde4-base packages 690 # Enable/disable handbooks for kde4-base packages
533 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 691 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
534 # kdelibs inherits kde4-base but handle installing the handbook itself 692 # kdelibs inherits kde4-base but handle installing the handbook itself
535 if ! has kde4-meta ${INHERITED}; then 693 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
536 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas 694 if [[ ${KDEBASE} == kde-base ]]; then
695 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
696 # documentation in kde4-functions
697 : ${KDE_DOC_DIRS:=doc}
698 local dir
699 for dir in ${KDE_DOC_DIRS}; do
700 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
701 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
702 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
703 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
704 -i CMakeLists.txt || die "failed to comment out handbook"
705 done
706 fi
707 else
708 enable_selected_doc_linguas
537 fi 709 fi
710 fi
538 711
539 [[ ${BUILD_TYPE} = live ]] && subversion_src_prepare 712 # SCM bootstrap
713 if [[ ${KDE_BUILD_TYPE} = live ]]; then
714 case ${KDE_SCM} in
715 svn) subversion_src_prepare ;;
716 esac
717 fi
540 718
541 # Apply patches 719 # Apply patches, cmake-utils does the job already
542 base_src_prepare 720 cmake-utils_src_prepare
543 epatch_user
544 721
545 # Save library dependencies 722 # Save library dependencies
546 if [[ -n ${KMSAVELIBS} ]] ; then 723 if [[ -n ${KMSAVELIBS} ]] ; then
547 save_library_dependencies 724 save_library_dependencies
548 fi 725 fi
549 726
550 # Inject library dependencies 727 # Inject library dependencies
551 if [[ -n ${KMLOADLIBS} ]] ; then 728 if [[ -n ${KMLOADLIBS} ]] ; then
552 load_library_dependencies 729 load_library_dependencies
553 fi 730 fi
731
732 # Hack for manuals relying on outdated DTD, only outside kde-base/...
733 if [[ -z ${KDEBASE} ]]; then
734 find "${S}" -name "*.docbook" \
735 -exec sed -i -r \
736 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
737 || die 'failed to fix DocBook variant version'
738 fi
554} 739}
555 740
556# @FUNCTION: kde4-base_src_configure 741# @FUNCTION: kde4-base_src_configure
557# @DESCRIPTION: 742# @DESCRIPTION:
558# Function for configuring the build of KDE4 applications. 743# Function for configuring the build of KDE4 applications.
560 debug-print-function ${FUNCNAME} "$@" 745 debug-print-function ${FUNCNAME} "$@"
561 746
562 # Build tests in src_test only, where we override this value 747 # Build tests in src_test only, where we override this value
563 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 748 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
564 749
565 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 750 if use_if_iuse debug; then
566 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
567 fi
568
569 if has debug ${IUSE//+} && use debug; then
570 # Set "real" debug mode 751 # Set "real" debug mode
571 CMAKE_BUILD_TYPE="Debugfull" 752 CMAKE_KDE_BUILD_TYPE="Debugfull"
572 else 753 else
573 # Handle common release builds 754 # Handle common release builds
574 append-cppflags -DQT_NO_DEBUG 755 append-cppflags -DQT_NO_DEBUG
575 fi 756 fi
576 757
577 # Set distribution name 758 # Set distribution name
578 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo) 759 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
579 760
580 # Here we set the install prefix 761 # Here we set the install prefix
581 cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 762 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
582 763
583 # Use colors 764 # Use colors
584 QTEST_COLORED=1 765 QTEST_COLORED=1
585 766
586 # Shadow existing /usr installations 767 # Shadow existing installations
587 unset KDEDIRS 768 unset KDEDIRS
588 769
589 # Handle kdeprefix-ed KDE 770 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
590 if [[ ${KDEDIR} != /usr ]]; then 771 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
591 # Override some environment variables - only when kdeprefix is different, 772 #kde-config -path data unavailable when cross-compiling
592 # to not break ccache/distcc 773 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
593 PATH="${EKDEDIR}/bin:${PATH}"
594 LDPATH="${EKDEDIR}/$(get_libdir)${LDPATH+:}${LDPATH}"
595 774
596 # Append full RPATH
597 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
598
599 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
600 # when more are present
601 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
602 fi
603
604 # Handle kdeprefix in application itself
605 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
606 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 775 # sysconf needs to be /etc, not /usr/etc
607 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 776 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
608 fi
609 777
610 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 778 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
779 if [[ ${mycmakeargs} ]]; then
780 eqawarn "mycmakeargs should always be declared as an array, not a string"
781 fi
611 mycmakeargs=(${mycmakeargs}) 782 mycmakeargs=(${mycmakeargs})
612 fi 783 fi
613 784
614 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}") 785 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
615 786
628# @FUNCTION: kde4-base_src_test 799# @FUNCTION: kde4-base_src_test
629# @DESCRIPTION: 800# @DESCRIPTION:
630# Function for testing KDE4 applications. 801# Function for testing KDE4 applications.
631kde4-base_src_test() { 802kde4-base_src_test() {
632 debug-print-function ${FUNCNAME} "$@" 803 debug-print-function ${FUNCNAME} "$@"
804
805 local kded4_pid
806
807 _test_runner() {
808 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
809 export $(dbus-launch)
810 kded4 2>&1 > /dev/null &
811 kded4_pid=$!
812 fi
813
814 cmake-utils_src_test
815 }
816
817 # When run as normal user during ebuild development with the ebuild command, the
818 # kde tests tend to access the session DBUS. This however is not possible in a real
819 # emerge or on the tinderbox.
820 # > make sure it does not happen, so bad tests can be recognized and disabled
821 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
633 822
634 # Override this value, set in kde4-base_src_configure() 823 # Override this value, set in kde4-base_src_configure()
635 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON) 824 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
636 cmake-utils_src_configure 825 cmake-utils_src_configure
637 kde4-base_src_compile 826 kde4-base_src_compile
638 827
639 cmake-utils_src_test 828 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
829 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
830 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
831 # surprise- we are already INSIDE virtualmake!!!
832 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
833 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
834 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
835 debug-print " kde4-base.eclass docs for details... Applying workaround."
836 _test_runner
837 else
838 VIRTUALX_COMMAND="_test_runner" virtualmake
839 fi
840 else
841 _test_runner
842 fi
843
844 if [ -n "${kded4_pid}" ] ; then
845 kill ${kded4_pid}
846 fi
847
848 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
849 kill ${DBUS_SESSION_BUS_PID}
850 fi
640} 851}
641 852
642# @FUNCTION: kde4-base_src_install 853# @FUNCTION: kde4-base_src_install
643# @DESCRIPTION: 854# @DESCRIPTION:
644# Function for installing KDE4 applications. 855# Function for installing KDE4 applications.
645kde4-base_src_install() { 856kde4-base_src_install() {
646 debug-print-function ${FUNCNAME} "$@" 857 debug-print-function ${FUNCNAME} "$@"
647 858
648 # Prefix support, for usage in ebuilds
649 if [[ ${EAPI} == 2 ]] && ! use prefix; then
650 ED=${D}
651 fi
652
653 if [[ -n ${KMSAVELIBS} ]] ; then 859 if [[ -n ${KMSAVELIBS} ]] ; then
654 install_library_dependencies 860 install_library_dependencies
655 fi 861 fi
656 862
657 kde4-base_src_make_doc 863 # Install common documentation of KDE4 applications
864 local doc
865 if ! has kde4-meta ${INHERITED}; then
866 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
867 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
868 done
869 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
870 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
871 done
872 fi
873
658 cmake-utils_src_install 874 cmake-utils_src_install
659}
660 875
661# @FUNCTION: kde4-base_src_make_doc 876 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
662# @DESCRIPTION: 877 # because then khelpcenter can't find the docs
663# Function for installing the documentation of KDE4 applications. 878 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
664kde4-base_src_make_doc() { 879 docompress -x ${PREFIX}/share/doc/HTML
665 debug-print-function ${FUNCNAME} "$@" 880}
666 881
667 local doc 882# @FUNCTION: kde4-base_pkg_preinst
668 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 883# @DESCRIPTION:
669 [[ -s ${doc} ]] && dodoc ${doc} 884# Function storing icon caches
670 done 885kde4-base_pkg_preinst() {
886 debug-print-function ${FUNCNAME} "$@"
671 887
672 if [[ -z ${KMNAME} ]]; then 888 gnome2_icon_savelist
673 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 889 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
674 if [[ -s ${doc} ]]; then 890 subversion_pkg_preinst
675 local doc_complete=${doc}
676 doc="${doc#*/}"
677 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
678 fi
679 done
680 fi 891 fi
681} 892}
682 893
683# @FUNCTION: kde4-base_pkg_postinst 894# @FUNCTION: kde4-base_pkg_postinst
684# @DESCRIPTION: 895# @DESCRIPTION:
685# Function to rebuild the KDE System Configuration Cache after an application has been installed. 896# Function to rebuild the KDE System Configuration Cache after an application has been installed.
686kde4-base_pkg_postinst() { 897kde4-base_pkg_postinst() {
687 debug-print-function ${FUNCNAME} "$@" 898 debug-print-function ${FUNCNAME} "$@"
688 899
900 gnome2_icon_cache_update
901 fdo-mime_desktop_database_update
902 fdo-mime_mime_database_update
689 buildsycoca 903 buildsycoca
690 904
691 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 905 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
692 echo 906 if [[ ${KDE_BUILD_TYPE} = live ]]; then
693 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
694 einfo "Use it at your own risk."
695 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
696 echo
697 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
698 # warning about kdeprefix for non-live users
699 echo
700 ewarn "WARNING! You have the kdeprefix useflag enabled."
701 ewarn "This setting is strongly discouraged and might lead to potential trouble"
702 ewarn "with KDE update strategies."
703 ewarn "You are using this setup at your own risk and the kde team does not"
704 ewarn "take responsibilities for dead kittens."
705 echo
706 fi
707 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && ! has_version 'kde-base/kdebase-runtime-meta' && ! has_version 'kde-base/kdebase-startkde'; then
708 # warn about not supported approach
709 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
710 echo 907 echo
908 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
909 einfo "Use it at your own risk."
910 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
911 echo
912 fi
913 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
914 if [[ ${KDEBASE} != kde-base ]] && \
915 ! has_version 'kde-apps/kdebase-runtime-meta' && \
916 ! has_version 'kde-base/kdebase-startkde'; then
917 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
918 echo
711 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\"" 919 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
712 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above." 920 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
713 ewarn "With this setting you are unsupported by KDE team." 921 ewarn "With this setting you are unsupported by KDE team."
714 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID." 922 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
923 fi
715 fi 924 fi
716 fi 925 fi
717} 926}
718 927
719# @FUNCTION: kde4-base_pkg_postrm 928# @FUNCTION: kde4-base_pkg_postrm
720# @DESCRIPTION: 929# @DESCRIPTION:
721# Function to rebuild the KDE System Configuration Cache after an application has been removed. 930# Function to rebuild the KDE System Configuration Cache after an application has been removed.
722kde4-base_pkg_postrm() { 931kde4-base_pkg_postrm() {
723 debug-print-function ${FUNCNAME} "$@" 932 debug-print-function ${FUNCNAME} "$@"
724 933
934 gnome2_icon_cache_update
935 fdo-mime_desktop_database_update
936 fdo-mime_mime_database_update
725 buildsycoca 937 buildsycoca
726} 938}
939
940fi

Legend:
Removed from v.1.58  
changed lines
  Added in v.1.157

  ViewVC Help
Powered by ViewVC 1.1.20